/* @license
	On-screen keyboard detector (OSKD) v.1.0.0
	(c) 2020-2020 Matthias Seemann
	OSKD may be freely distributed under the MIT license.
*/
!function(t,n){"object"==typeof exports&&"undefined"!=typeof module?n(exports):"function"==typeof define&&define.amd?define(["exports"],n):n((t=t||self).OSKD={})}(this,(function(t){"use strict";
/** @license MIT License (c) copyright 2010-2016 original author or authors */function n(t,n){for(var e=n.length,r=new Array(e+1),i=0;i<e;++i)r[i]=n[i];return r[e]=t,r}function e(t,n,e){for(var r=n,i=0,o=e.length;i<o;++i)r=t(r,e[i],i);return r}function r(t,n){if(t<0)throw new TypeError("i must be >= 0");var e=n.length;return 0===e||t>=e?n:1===e?[]:function(t,n,e){var r=new Array(e),i=void 0;for(i=0;i<t;++i)r[i]=n[i];for(i=t;i<e;++i)r[i]=n[i+1];return r}(t,n,e-1)}function i(t,n){for(var e=0,r=n.length;e<r;++e)if(t===n[e])return e;return-1}
/** @license MIT License (c) copyright 2010-2016 original author or authors */var o=function(t){return t};function s(t){return function n(e,r){switch(arguments.length){case 0:return n;case 1:return function(n){return t(e,n)};default:return t(e,r)}}}function u(t){return function n(e,r,i){switch(arguments.length){case 0:return n;case 1:return s((function(n,r){return t(e,n,r)}));case 2:return function(n){return t(e,r,n)};default:return t(e,r,i)}}}var c=function(t,n){if(!(t instanceof n))throw new TypeError("Cannot call a class as a function")},h=function(){function t(n,e,r,i,o){c(this,t),this.time=n,this.localOffset=e,this.period=r,this.task=i,this.scheduler=o,this.active=!0}return t.prototype.run=function(){return this.task.run(this.time-this.localOffset)},t.prototype.error=function(t){return this.task.error(this.time-this.localOffset,t)},t.prototype.dispose=function(){return this.active=!1,this.scheduler.cancel(this),this.task.dispose()},t}(),f=function(){function t(n,e){c(this,t),this.origin=n,this.scheduler=e}return t.prototype.currentTime=function(){return this.scheduler.currentTime()-this.origin},t.prototype.scheduleTask=function(t,n,e,r){return this.scheduler.scheduleTask(t+this.origin,n,e,r)},t.prototype.relative=function(n){return new t(n+this.origin,this.scheduler)},t.prototype.cancel=function(t){return this.scheduler.cancel(t)},t.prototype.cancelAll=function(t){return this.scheduler.cancelAll(t)},t}(),a=function(t){return Promise.resolve(t).then(p)};
/** @license MIT License (c) copyright 2010-2017 original author or authors */function p(t){try{return t.run()}catch(n){return t.error(n)}}
/** @license MIT License (c) copyright 2010-2017 original author or authors */var l=function(){function t(n,e){var r=this;c(this,t),this.timer=n,this.timeline=e,this._timer=null,this._nextArrival=1/0,this._runReadyTasksBound=function(){return r._runReadyTasks(r.currentTime())}}return t.prototype.currentTime=function(){return this.timer.now()},t.prototype.scheduleTask=function(t,n,e,r){var i=this.currentTime()+Math.max(0,n),o=new h(i,t,e,r,this);return this.timeline.add(o),this._scheduleNextRun(),o},t.prototype.relative=function(t){return new f(t,this)},t.prototype.cancel=function(t){t.active=!1,this.timeline.remove(t)&&this._reschedule()},t.prototype.cancelAll=function(t){this.timeline.removeAll(t),this._reschedule()},t.prototype._reschedule=function(){this.timeline.isEmpty()?this._unschedule():this._scheduleNextRun(this.currentTime())},t.prototype._unschedule=function(){this.timer.clearTimer(this._timer),this._timer=null},t.prototype._scheduleNextRun=function(){if(!this.timeline.isEmpty()){var t=this.timeline.nextArrival();null===this._timer?this._scheduleNextArrival(t):t<this._nextArrival&&(this._unschedule(),this._scheduleNextArrival(t))}},t.prototype._scheduleNextArrival=function(t){this._nextArrival=t;var n=Math.max(0,t-this.currentTime());this._timer=this.timer.setTimer(this._runReadyTasksBound,n)},t.prototype._runReadyTasks=function(){this._timer=null,this.timeline.runTasks(this.currentTime(),p),this._scheduleNextRun()},t}(),d=function(){function t(){c(this,t),this.tasks=[]}return t.prototype.nextArrival=function(){return this.isEmpty()?1/0:this.tasks[0].time},t.prototype.isEmpty=function(){return 0===this.tasks.length},t.prototype.add=function(t){v(t,this.tasks)},t.prototype.remove=function(t){var n=w(m(t),this.tasks);if(n>=0&&n<this.tasks.length){var e=this.tasks[n].events,r=i(t,e);if(r>=0)return e.splice(r,1),0===e.length&&this.tasks.splice(n,1),!0}return!1},t.prototype.removeAll=function(t){for(var n=0;n<this.tasks.length;++n)g(t,this.tasks[n])},t.prototype.runTasks=function(t,n){for(var e=this.tasks,r=e.length,i=0;i<r&&e[i].time<=t;)++i;this.tasks=e.slice(i);for(var o=0;o<i;++o)this.tasks=y(n,e[o].events,this.tasks)},t}();
/** @license MIT License (c) copyright 2010-2017 original author or authors */function y(t,n,e){for(var r=0;r<n.length;++r){var i=n[r];i.active&&(t(i),i.period>=0&&i.active&&(i.time=i.time+i.period,v(i,e)))}return e}function v(t,n){var e=n.length,r=m(t);if(0!==e){var i=w(r,n);i>=e?n.push(k(r,[t])):function(t,n,e,r){var i=n[r];e===i.time?function(t,n){0===n.length||t.time>=n[n.length-1].time?n.push(t):function(t,n){for(var e=0;e<n.length;e++)if(t.time<n[e].time){n.splice(e,0,t);break}}(t,n)}(t,i.events):n.splice(r,0,k(e,[t]))}(t,n,r,i)}else n.push(k(r,[t]))}function m(t){return Math.floor(t.time)}function g(t,n){n.events=function(t,n){for(var e,r=n.length,i=new Array(r),o=0,s=0;s<r;++s)t(e=n[s])||(i[o]=e,++o);return i.length=o,i}(t,n.events)}function w(t,n){for(var e=0,r=n.length,i=void 0,o=void 0;e<r;){if(t===(o=n[i=Math.floor((e+r)/2)]).time)return i;t<o.time?r=i:e=i+1}return r}var k=function(t,n){return{time:t,events:n}},_=function(){function t(n){c(this,t),this._clock=n}return t.prototype.now=function(){return this._clock.now()},t.prototype.setTimer=function(t,n){return n<=0?function(t){var n=new b(t);return a(n),n}
/** @license MIT License (c) copyright 2010-2017 original author or authors */(t):setTimeout(t,n)},t.prototype.clearTimer=function(t){return t instanceof b?t.cancel():clearTimeout(t)},t}(),b=function(){function t(n){c(this,t),this.f=n,this.active=!0}return t.prototype.run=function(){return this.active&&this.f()},t.prototype.error=function(t){throw t},t.prototype.cancel=function(){this.active=!1},t}();
/** @license MIT License (c) copyright 2010-2017 original author or authors */var O=function(){function t(n,e){c(this,t),this.origin=e,this.clock=n}return t.prototype.now=function(){return this.clock.now()-this.origin},t}(),S=function(){function t(n,e){c(this,t),this.origin=e,this.hrtime=n}return t.prototype.now=function(){var t=this.hrtime(this.origin);return(1e9*t[0]+t[1])/1e6},t}(),E=function(t){return new O(t,t.now())},T=function(){return"undefined"!=typeof performance&&"function"==typeof performance.now?E(performance):"undefined"!=typeof process&&"function"==typeof process.hrtime?new S(process.hrtime,process.hrtime()):E(Date)},A=function(t){return t.currentTime()},x=s((function(t,n){return n.scheduleTask(0,0,-1,t)})),j=u((function(t,n,e){return e.scheduleTask(0,t,-1,n)})),I=function(t){return t.dispose()},q=s((function(t,n){return new f(t,n)})),H=function(){return new l(P(),new d)},P=function(){return new _(T())},R=function(t,n){if(!(t instanceof n))throw new TypeError("Cannot call a class as a function")},z=function(){return N},N=new(function(){function t(){R(this,t)}return t.prototype.dispose=function(){},t}()),C=function(t){return new D(t)},D=function(){function t(n){R(this,t),this.disposed=!1,this.disposable=n}return t.prototype.dispose=function(){this.disposed||(this.disposed=!0,this.disposable.dispose(),this.disposable=void 0)},t}(),M=function(t){var n=e(U,[],t);return 0===n.length?z():new V(n)},B=s((function(t,n){return M([t,n])})),U=function(t,e){return function(t){return t===N}(e)?t:e instanceof V?t.concat(e.disposables):n(e,t)},V=function(){function t(n){R(this,t),this.disposables=n}return t.prototype.dispose=function(){F(L(this.disposables))},t}(),L=function(t){return e(W,[],t)},W=function(t,n){try{n.dispose()}catch(n){t.push(n)}return t},F=function(t){if(t.length>0)throw new J(t.length+" errors",t)},J=function(t){function n(e,r){t.call(this,e),this.message=e,this.name=n.name,this.errors=r,t.captureStackTrace&&t.captureStackTrace(this,n),this.stack=""+this.stack+K(this.errors)}return n.prototype=Object.create(t.prototype),n}(Error),K=function(t){return e(X,"",t)},X=function(t,n,e){return t+"\n["+(e+1)+"] "+n.stack},G=u((function(t,n,e){try{n.dispose()}catch(n){e.error(t,n)}}));function Q(t){throw t}var Y=function(t,n){if(!(t instanceof n))throw new TypeError("Cannot call a class as a function")},Z=function(t,n){if("function"!=typeof n&&null!==n)throw new TypeError("Super expression must either be null or a function, not "+typeof n);t.prototype=Object.create(n&&n.prototype,{constructor:{value:t,enumerable:!1,writable:!0,configurable:!0}}),n&&(Object.setPrototypeOf?Object.setPrototypeOf(t,n):t.__proto__=n)},$=function(t,n){if(!t)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!n||"object"!=typeof n&&"function"!=typeof n?t:n},tt=function(t,n,e){return new rt(t,n,e)},nt=function(t,n){return tt(it,t,n)},et=function(t){return tt(ot,void 0,t)},rt=function(){function t(n,e,r){Y(this,t),this._run=n,this.value=e,this.sink=r,this.active=!0}return t.prototype.dispose=function(){this.active=!1},t.prototype.run=function(t){if(this.active){var n=this._run;n(t,this.value,this.sink)}},t.prototype.error=function(t,n){if(!this.active)
/** @license MIT License (c) copyright 2010-2016 original author or authors */
return function(t){setTimeout(Q,0,t)}(n);this.sink.error(t,n)},t}(),it=function(t,n,e){return e.event(t,n)},ot=function(t,n,e){return e.end(t)},st=function(){return ct},ut=function(t){return t===ct},ct=new(function(){function t(){Y(this,t)}return t.prototype.run=function(t,n){return x(et(t),n)},t}()),ht=function(t,n){return new ft(t,n)},ft=function(){function t(n,e){Y(this,t),this.time=n,this.value=e}return t.prototype.run=function(t,n){return j(this.time,tt(at,this.value,t),n)},t}();function at(t,n,e){e.event(t,n),e.end(t)}
/** @license MIT License (c) copyright 2010-2017 original author or authors */var pt=function(t){return ht(0,t)},lt=function(){function t(n){Y(this,t),this.sink=n}return t.prototype.event=function(t,n){return this.sink.event(t,n)},t.prototype.end=function(t){return this.sink.end(t)},t.prototype.error=function(t,n){return this.sink.error(t,n)},t}(),dt=function(){function t(n,e){Y(this,t),this.p=n,this.source=e}return t.prototype.run=function(t,n){return this.source.run(new yt(this.p,t),n)},t.create=function(n,e){return ut(e)?e:e instanceof t?new t(vt(e.p,n),e.source):new t(n,e)},t}(),yt=function(t){function n(e,r){Y(this,n);var i=$(this,t.call(this,r));return i.p=e,i}return Z(n,t),n.prototype.event=function(t,n){(0,this.p)(n)&&this.sink.event(t,n)},n}(lt),vt=function(t,n){return function(e){return t(e)&&n(e)}},mt=function(){function t(n,e,r){Y(this,t),this.p=n,this.f=e,this.source=r}return t.prototype.run=function(t,n){return this.source.run(new gt(this.p,this.f,t),n)},t}(),gt=function(t){function n(e,r,i){Y(this,n);var o=$(this,t.call(this,i));return o.p=e,o.f=r,o}return Z(n,t),n.prototype.event=function(t,n){var e=this.f;(0,this.p)(n)&&this.sink.event(t,e(n))},n}(lt),wt=function(){function t(n,e){Y(this,t),this.f=n,this.source=e}return t.prototype.run=function(t,n){return this.source.run(new kt(this.f,t),n)},t.create=function(n,e){return ut(e)?st():e instanceof t?new t(function(t,n){return function(e){return t(n(e))}}(n,e.f),e.source):e instanceof dt?new mt(e.p,n,e.source):new t(n,e)},t}(),kt=function(t){function n(e,r){Y(this,n);var i=$(this,t.call(this,r));return i.f=e,i}return Z(n,t),n.prototype.event=function(t,n){var e=this.f;this.sink.event(t,e(n))},n}(lt),_t=function(){function t(){Y(this,t),this.disposable=void 0,this.disposed=!1}return t.prototype.setDisposable=function(t){if(void 0!==this.disposable)throw new Error("setDisposable called more than once");this.disposable=t,this.disposed&&t.dispose()},t.prototype.dispose=function(){this.disposed||(this.disposed=!0,void 0!==this.disposable&&this.disposable.dispose())},t}(),bt=function(t,n){return ut(n)?st():new Ot(t,n)},Ot=function(){function t(n,e){Y(this,t),this.p=n,this.source=e}return t.prototype.run=function(t,n){return this.source.run(new St(this.p,t),n)},t}(),St=function(t){function n(e,r){Y(this,n);var i=$(this,t.call(this,r));return i.p=e,i.skipping=!1,i}return Z(n,t),n.prototype.event=function(t,n){if(!this.skipping){var e=this.p;this.skipping=e(n),this.sink.event(t,n),this.skipping&&this.sink.end(t)}},n}(lt),Et=s((function(t,n){return new Promise((function(e,r){return function(t,n,e,r){var i=new _t,o=new Tt(e,r,i);i.setDisposable(t.run(o,n))}(t,n,e,r)}))}));
/** @license MIT License (c) copyright 2010-2017 original author or authors */var Tt=function(){function t(n,e,r){Y(this,t),this._end=n,this._error=e,this._disposable=r,this.active=!0}return t.prototype.event=function(t,n){},t.prototype.end=function(t){this.active&&this._dispose(this._error,this._end,void 0)},t.prototype.error=function(t,n){this._dispose(this._error,this._error,n)},t.prototype._dispose=function(t,n,e){this.active=!1,function(t,n,e,r){try{r.dispose()}catch(n){return void t(n)}n(e)}
/** @license MIT License (c) copyright 2010-2017 original author or authors */(t,n,e,this._disposable)},t}();var At=function(){function t(n,e){Y(this,t),this.sink=e,this.offset=n}return t.prototype.event=function(t,n){this.sink.event(t+this.offset,n)},t.prototype.error=function(t,n){this.sink.error(t+this.offset,n)},t.prototype.end=function(t){this.sink.end(t+this.offset)},t}(),xt=function(){function t(n,e){Y(this,t),this.origin=n,this.source=e}return t.prototype.run=function(t,n){return this.source.run(jt(this.origin,t),q(this.origin,n))},t}(),jt=function(t,n){return n instanceof At?new At(t+n.offset,n.sink):new At(t,n)},It=function(t,n,e){return new qt(t,n,e)},qt=function(){function t(n,e,r){Y(this,t),this.source=r,this.f=n,this.value=e}return t.prototype.run=function(t,n){var e=x(nt(this.value,t),n),r=this.source.run(new Ht(this.f,this.value,t),n);return B(e,r)},t}(),Ht=function(t){function n(e,r,i){Y(this,n);var o=$(this,t.call(this,i));return o.f=e,o.value=r,o}return Z(n,t),n.prototype.event=function(t,n){var e=this.f;this.value=e(this.value,n),this.sink.event(t,this.value)},n}(lt),Pt=function(){function t(n,e){Y(this,t),this.f=n,this.source=e}return t.prototype.run=function(t,n){return new Rt(this.f,this.source,t,n)},t}(),Rt=function(t){function n(e,r,i,o){Y(this,n);var s=$(this,t.call(this,i));return s.f=e,s.scheduler=o,s.active=!0,s.disposable=C(r.run(s,o)),s}return Z(n,t),n.prototype.event=function(t,n){this.active&&this.sink.event(t,n)},n.prototype.end=function(t){this.active&&(G(t,this.disposable,this.sink),this._startNext(t,this.sink))},n.prototype._startNext=function(t,n){try{this.disposable=this._continue(this.f,t,n)}catch(e){n.error(t,e)}},n.prototype._continue=function(t,n,e){return function(t,n,e){return e.run(t,n)}(e,this.scheduler,(r=n,i=t(),new xt(r,i)));var r,i},n.prototype.dispose=function(){return this.active=!1,this.disposable.dispose()},n}(lt),zt=function(t,n){return function(t,n){return new Pt(t,n)}((function(){return n}),pt(t))},Nt=function(t,n){return wt.create(t,n)},Ct=function(t,n){return new Dt(t,n)},Dt=function(){function t(n,e){Y(this,t),this.source=e,this.f=n}return t.prototype.run=function(t,n){return this.source.run(new Mt(this.f,t),n)},t}(),Mt=function(t){function n(e,r){Y(this,n);var i=$(this,t.call(this,r));return i.f=e,i}return Z(n,t),n.prototype.event=function(t,n){(0,this.f)(n),this.sink.event(t,n)},n}(lt),Bt=function(t){function n(e,r){Y(this,n);var i=$(this,t.call(this,r));return i.index=e,i.active=!0,i.value=void 0,i}return Z(n,t),n.prototype.event=function(t,n){this.active&&(this.value=n,this.sink.event(t,this))},n.prototype.end=function(t){this.active&&(this.active=!1,this.sink.event(t,this))},n}(lt),Ut=function(t,n,e){return ut(e)?st():new Vt(t,n,e)},Vt=function(){function t(n,e,r){Y(this,t),this.f=n,this.concurrency=e,this.source=r}return t.prototype.run=function(t,n){return new Lt(this.f,this.concurrency,this.source,t,n)},t}(),Lt=function(){function t(n,e,r,i,o){Y(this,t),this.f=n,this.concurrency=e,this.sink=i,this.scheduler=o,this.pending=[],this.current=[],this.disposable=C(r.run(this,o)),this.active=!0}return t.prototype.event=function(t,n){this._addInner(t,n)},t.prototype._addInner=function(t,n){this.current.length<this.concurrency?this._startInner(t,n):this.pending.push(n)},t.prototype._startInner=function(t,n){try{this._initInner(t,n)}catch(n){this.error(t,n)}},t.prototype._initInner=function(t,n){var e=new Ft(t,this,this.sink);e.disposable=Wt(this.f,t,n,e,this.scheduler),this.current.push(e)},t.prototype.end=function(t){this.active=!1,G(t,this.disposable,this.sink),this._checkEnd(t)},t.prototype.error=function(t,n){this.active=!1,this.sink.error(t,n)},t.prototype.dispose=function(){this.active=!1,this.pending.length=0,this.disposable.dispose(),M(this.current).dispose()},t.prototype._endInner=function(t,n){var e=this.current.indexOf(n);e>=0&&this.current.splice(e,1),G(t,n,this),0===this.pending.length?this._checkEnd(t):this._startInner(t,this.pending.shift())},t.prototype._checkEnd=function(t){this.active||0!==this.current.length||this.sink.end(t)},t}(),Wt=function(t,n,e,r,i){return t(e).run(r,q(n,i))},Ft=function(){function t(n,e,r){Y(this,t),this.time=n,this.outer=e,this.sink=r,this.disposable=z()}return t.prototype.event=function(t,n){this.sink.event(t+this.time,n)},t.prototype.end=function(t){this.outer._endInner(t+this.time,this)},t.prototype.error=function(t,n){this.outer.error(t+this.time,n)},t.prototype.dispose=function(){return this.disposable.dispose()},t}(),Jt=function(t){return function(t,n){return Ut(o,t,n)}(1/0,t)};
/** @license MIT License (c) copyright 2010-2016 original author or authors */
function Kt(t,n){return Xt([t,n])}var Xt=function(t){return Gt(Qt(t))},Gt=function(t){return 0===t.length?st():1===t.length?t[0]:new $t(e(Zt,[],t))},Qt=function(t){return t.filter(Yt)},Yt=function(t){return!ut(t)},Zt=function(t,n){return t.concat(n instanceof $t?n.sources:n)},$t=function(){function t(n){Y(this,t),this.sources=n}return t.prototype.run=function(t,n){for(var e,r=this.sources.length,i=new Array(r),o=new Array(r),s=new tn(i,o,t),u=0;u<r;++u)e=o[u]=new Bt(u,s),i[u]=this.sources[u].run(e,n);return M(i)},t}(),tn=function(t){function n(e,r,i){Y(this,n);var o=$(this,t.call(this,i));return o.disposables=e,o.activeCount=r.length,o}return Z(n,t),n.prototype.event=function(t,n){n.active?this.sink.event(t,n.value):this._dispose(t,n.index)},n.prototype._dispose=function(t,n){G(t,this.disposables[n],this.sink),0==--this.activeCount&&this.sink.end(t)},n}(lt),nn=function(t,n,e){return ut(e)||ut(n)?st():new en(t,n,e)},en=function(){function t(n,e,r){Y(this,t),this.f=n,this.values=e,this.sampler=r}return t.prototype.run=function(t,n){var e=new rn(this.f,t),r=this.values.run(e.latest,n),i=this.sampler.run(e,n);return B(i,r)},t}(),rn=function(t){function n(e,r){Y(this,n);var i=$(this,t.call(this,r));return i.f=e,i.latest=new on(i),i}return Z(n,t),n.prototype.event=function(t,n){if(this.latest.hasValue){var e=this.f;this.sink.event(t,e(this.latest.value,n))}},n}(lt),on=function(t){function n(e){Y(this,n);var r=$(this,t.call(this,e));return r.hasValue=!1,r}return Z(n,t),n.prototype.event=function(t,n){this.value=n,this.hasValue=!0},n.prototype.end=function(){},n}(lt),sn=function(t){return ut(t)?st():new un(t)},un=function(){function t(n){Y(this,t),this.source=n}return t.prototype.run=function(t,n){var e=new cn(t,n);return B(e,this.source.run(e,n))},t}(),cn=function(){function t(n,e){Y(this,t),this.sink=n,this.scheduler=e,this.current=null,this.ended=!1}return t.prototype.event=function(t,n){this._disposeCurrent(t),this.current=new hn(n,t,1/0,this,this.sink,this.scheduler)},t.prototype.end=function(t){this.ended=!0,this._checkEnd(t)},t.prototype.error=function(t,n){this.ended=!0,this.sink.error(t,n)},t.prototype.dispose=function(){return this._disposeCurrent(A(this.scheduler))},t.prototype._disposeCurrent=function(t){if(null!==this.current)return this.current._dispose(t)},t.prototype._disposeInner=function(t,n){n._dispose(t),n===this.current&&(this.current=null)},t.prototype._checkEnd=function(t){this.ended&&null===this.current&&this.sink.end(t)},t.prototype._endInner=function(t,n){this._disposeInner(t,n),this._checkEnd(t)},t.prototype._errorInner=function(t,n,e){this._disposeInner(t,e),this.sink.error(t,n)},t}(),hn=function(){function t(n,e,r,i,o,s){Y(this,t),this.min=e,this.max=r,this.outer=i,this.sink=o,this.disposable=n.run(this,q(e,s))}return t.prototype.event=function(t,n){var e=Math.max(0,t+this.min);e<this.max&&this.sink.event(e,n)},t.prototype.end=function(t){this.outer._endInner(t+this.min,this)},t.prototype.error=function(t,n){this.outer._errorInner(t+this.min,n,this)},t.prototype._dispose=function(t){G(t,this.disposable,this.sink)},t}(),fn=function(t,n){return dt.create(t,n)},an=function(t){return pn(yn,t)},pn=function(t,n){return ut(n)?st():new ln(t,n)},ln=function(){function t(n,e){Y(this,t),this.equals=n,this.source=e}return t.prototype.run=function(t,n){return this.source.run(new dn(this.equals,t),n)},t}(),dn=function(t){function n(e,r){Y(this,n);var i=$(this,t.call(this,r));return i.equals=e,i.value=void 0,i.init=!0,i}return Z(n,t),n.prototype.event=function(t,n){this.init?(this.init=!1,this.value=n,this.sink.event(t,n)):this.equals(this.value,n)||(this.value=n,this.sink.event(t,n))},n}(lt);function yn(t,n){return t===n}
/** @license MIT License (c) copyright 2010-2016 original author or authors */var vn=function(t,n){return new mn(t,n)},mn=function(){function t(n,e){Y(this,t),this.maxSignal=n,this.source=e}return t.prototype.run=function(t,n){var e=new _t,r=this.source.run(t,n),i=this.maxSignal.run(new gn(t,e),n);return e.setDisposable(B(r,i)),e},t}(),gn=function(t){function n(e,r){Y(this,n);var i=$(this,t.call(this,e));return i.disposable=r,i}return Z(n,t),n.prototype.event=function(t,n){this.disposable.dispose(),this.sink.end(t)},n.prototype.end=function(){},n}(lt),wn=function(t,n){return t<=0?n:new kn(t,n)},kn=function(){function t(n,e){Y(this,t),this.dt=n,this.source=e}return t.prototype.run=function(t,n){var e=new _n(this.dt,t,n);return B(e,this.source.run(e,n))},t}(),_n=function(t){function n(e,r,i){Y(this,n);var o=$(this,t.call(this,r));return o.dt=e,o.scheduler=i,o.tasks=[],o}return Z(n,t),n.prototype.dispose=function(){this.tasks.forEach(I)},n.prototype.event=function(t,n){this.tasks.push(j(this.dt,nt(n,this.sink),this.scheduler))},n.prototype.end=function(t){this.tasks.push(j(this.dt,et(this.sink),this.scheduler))},n}(lt),bn=function(t,n){return ut(n)?st():new On(t,n)},On=function(){function t(n,e){Y(this,t),this.dt=n,this.source=e}return t.prototype.run=function(t,n){return new Sn(this.dt,this.source,t,n)},t}(),Sn=function(){function t(n,e,r,i){Y(this,t),this.dt=n,this.sink=r,this.scheduler=i,this.value=void 0,this.timer=null,this.disposable=e.run(this,i)}return t.prototype.event=function(t,n){this._clearTimer(),this.value=n,this.timer=j(this.dt,new En(this,n),this.scheduler)},t.prototype._event=function(t,n){this._clearTimer(),this.sink.event(t,n)},t.prototype.end=function(t){this._clearTimer()&&(this.sink.event(t,this.value),this.value=void 0),this.sink.end(t)},t.prototype.error=function(t,n){this._clearTimer(),this.sink.error(t,n)},t.prototype.dispose=function(){this._clearTimer(),this.disposable.dispose()},t.prototype._clearTimer=function(){return null!==this.timer&&(this.timer.dispose(),this.timer=null,!0)},t}(),En=function(){function t(n,e){Y(this,t),this.debounce=n,this.value=e}return t.prototype.run=function(t){this.debounce._event(t,this.value)},t.prototype.error=function(t,n){this.debounce.error(t,n)},t.prototype.dispose=function(){},t}();
/** @license MIT License (c) copyright 2010-2016 original author or authors */
function Tn(t,n,e){try{e.event(t,n)}catch(n){e.error(t,n)}}function An(t,n){try{n.end(t)}catch(e){n.error(t,e)}}var xn=function(t){return t instanceof jn||ut(t)?t:new jn(t)},jn=function(){function t(n){Y(this,t),this.source=new In(n)}return t.prototype.run=function(t,n){return this.source.run(t,n)},t}(),In=function(){function t(n){Y(this,t),this.source=n,this.sinks=[],this.disposable=z()}return t.prototype.run=function(t,n){return 1===this.add(t)&&(this.disposable=this.source.run(this,n)),C(new qn(this,t))},t.prototype.dispose=function(){var t=this.disposable;return this.disposable=z(),t.dispose()},t.prototype.add=function(t){return this.sinks=n(t,this.sinks),this.sinks.length},t.prototype.remove=function(t){var n=i(t,this.sinks);return n>=0&&(this.sinks=r(n,this.sinks)),this.sinks.length},t.prototype.event=function(t,n){var e=this.sinks;if(1===e.length)return e[0].event(t,n);for(var r=0;r<e.length;++r)Tn(t,n,e[r])},t.prototype.end=function(t){for(var n=this.sinks,e=0;e<n.length;++e)An(t,n[e])},t.prototype.error=function(t,n){for(var e=this.sinks,r=0;r<e.length;++r)e[r].error(t,n)},t}(),qn=function(){function t(n,e){Y(this,t),this.source=n,this.sink=e}return t.prototype.dispose=function(){0===this.source.remove(this.sink)&&this.source.dispose()},t}(),Hn=s(Et),Pn=u(It),Rn=s(zt),zn=s(Nt),Nn=s(Ct),Cn=s(Kt),Dn=u(nn),Mn=s(fn),Bn=s(bt),Un=s(vn),Vn=s(wn),Ln=s(bn),Wn=function(t,n,e){return void 0===e&&(e=!1),new Gn(t,n,e)},Fn=function(t,n){return void 0===n&&(n=!1),Wn("focusin",t,n)},Jn=function(t,n){return void 0===n&&(n=!1),Wn("focusout",t,n)},Kn=function(t,n){return void 0===n&&(n=!1),Wn("change",t,n)},Xn=function(t,n){return void 0===n&&(n=!1),Wn("resize",t,n)},Gn=function(t,n,e){this.event=t,this.node=n,this.capture=e};Gn.prototype.run=function(t,n){var e=this,r=function(e){return function(t,n,e){try{e.event(t,n)}catch(n){e.error(t,n)}}(A(n),e,t)};return this.node.addEventListener(this.event,r,this.capture),{dispose:function(){return e.node.removeEventListener(e.event,r,e.capture)}}};var Qn=function(){var t=[];return[function(n){return Yn(t,n)},new Zn(t)]},Yn=function(t,n){return t.forEach((function(t){var e=t.sink;return function(t,n,e){try{e.event(t,n)}catch(n){e.error(t,n)}}(t.scheduler.currentTime(),n,e)}))},Zn=function(){function t(t){this.sinks=t}return t.prototype.run=function(t,n){var e={sink:t,scheduler:n};return this.sinks.push(e),new $n(e,this.sinks)},t}(),$n=function(){function t(t,n){this.sink=t,this.sinks=n}return t.prototype.dispose=function(){var t=this.sinks.indexOf(this.sink);t>=0&&this.sinks.splice(t,1)},t}();function te(t){return null!=t&&"object"==typeof t&&!0===t["@@functional/placeholder"]}function ne(t){return function n(e){return 0===arguments.length||te(e)?n:t.apply(this,arguments)}}var ee=ne((function(t){return function(){return t}}));function re(t){return function n(e,r){switch(arguments.length){case 0:return n;case 1:return te(e)?n:ne((function(n){return t(e,n)}));default:return te(e)&&te(r)?n:te(e)?ne((function(n){return t(n,r)})):te(r)?ne((function(n){return t(e,n)})):t(e,r)}}}function ie(t){return function n(e,r,i){switch(arguments.length){case 0:return n;case 1:return te(e)?n:re((function(n,r){return t(e,n,r)}));case 2:return te(e)&&te(r)?n:te(e)?re((function(n,e){return t(n,r,e)})):te(r)?re((function(n,r){return t(e,n,r)})):ne((function(n){return t(e,r,n)}));default:return te(e)&&te(r)&&te(i)?n:te(e)&&te(r)?re((function(n,e){return t(n,e,i)})):te(e)&&te(i)?re((function(n,e){return t(n,r,e)})):te(r)&&te(i)?re((function(n,r){return t(e,n,r)})):te(e)?ne((function(n){return t(n,r,i)})):te(r)?ne((function(n){return t(e,n,i)})):te(i)?ne((function(n){return t(e,r,n)})):t(e,r,i)}}}var oe=ie((function(t,n,e){var r={};for(var i in e)r[i]=e[i];return r[t]=n,r})),se=re((function(t,n){return n(t)}));function ue(t,n){switch(t){case 0:return function(){return n.apply(this,arguments)};case 1:return function(t){return n.apply(this,arguments)};case 2:return function(t,e){return n.apply(this,arguments)};case 3:return function(t,e,r){return n.apply(this,arguments)};case 4:return function(t,e,r,i){return n.apply(this,arguments)};case 5:return function(t,e,r,i,o){return n.apply(this,arguments)};case 6:return function(t,e,r,i,o,s){return n.apply(this,arguments)};case 7:return function(t,e,r,i,o,s,u){return n.apply(this,arguments)};case 8:return function(t,e,r,i,o,s,u,c){return n.apply(this,arguments)};case 9:return function(t,e,r,i,o,s,u,c,h){return n.apply(this,arguments)};case 10:return function(t,e,r,i,o,s,u,c,h,f){return n.apply(this,arguments)};default:throw new Error("First argument to _arity must be a non-negative integer no greater than ten")}}function ce(t,n){return function(){return n.call(this,t.apply(this,arguments))}}var he=Array.isArray||function(t){return null!=t&&t.length>=0&&"[object Array]"===Object.prototype.toString.call(t)};function fe(t){return"[object String]"===Object.prototype.toString.call(t)}var ae=ne((function(t){return!!he(t)||!!t&&("object"==typeof t&&(!fe(t)&&(1===t.nodeType?!!t.length:0===t.length||t.length>0&&(t.hasOwnProperty(0)&&t.hasOwnProperty(t.length-1)))))})),pe=function(){function t(t){this.f=t}return t.prototype["@@transducer/init"]=function(){throw new Error("init not implemented on XWrap")},t.prototype["@@transducer/result"]=function(t){return t},t.prototype["@@transducer/step"]=function(t,n){return this.f(t,n)},t}();var le=re((function(t,n){return ue(t.length,(function(){return t.apply(n,arguments)}))}));function de(t,n,e){for(var r=e.next();!r.done;){if((n=t["@@transducer/step"](n,r.value))&&n["@@transducer/reduced"]){n=n["@@transducer/value"];break}r=e.next()}return t["@@transducer/result"](n)}function ye(t,n,e,r){return t["@@transducer/result"](e[r](le(t["@@transducer/step"],t),n))}var ve="undefined"!=typeof Symbol?Symbol.iterator:"@@iterator";function me(t,n,e){if("function"==typeof t&&(t=function(t){return new pe(t)}(t)),ae(e))return function(t,n,e){for(var r=0,i=e.length;r<i;){if((n=t["@@transducer/step"](n,e[r]))&&n["@@transducer/reduced"]){n=n["@@transducer/value"];break}r+=1}return t["@@transducer/result"](n)}(t,n,e);if("function"==typeof e["fantasy-land/reduce"])return ye(t,n,e,"fantasy-land/reduce");if(null!=e[ve])return de(t,n,e[ve]());if("function"==typeof e.next)return de(t,n,e);if("function"==typeof e.reduce)return ye(t,n,e,"reduce");throw new TypeError("reduce: list must be array or iterable")}var ge=ie(me);function we(t,n){return function(){var e=arguments.length;if(0===e)return n();var r=arguments[e-1];return he(r)||"function"!=typeof r[t]?n.apply(this,arguments):r[t].apply(r,Array.prototype.slice.call(arguments,0,e-1))}}var ke=ne(we("tail",ie(we("slice",(function(t,n,e){return Array.prototype.slice.call(e,t,n)})))(1,1/0)));function _e(){if(0===arguments.length)throw new Error("pipe requires at least one argument");return ue(arguments[0].length,ge(ce,arguments[0],ke(arguments)))}var be=ne((function(t){return fe(t)?t.split("").reverse().join(""):Array.prototype.slice.call(t,0).reverse()}));function Oe(){if(0===arguments.length)throw new Error("compose requires at least one argument");return _e.apply(this,be(arguments))}var Se=re((function(t,n){return 1===t?ne(n):ue(t,function t(n,e,r){return function(){for(var i=[],o=0,s=n,u=0;u<e.length||o<arguments.length;){var c;u<e.length&&(!te(e[u])||o>=arguments.length)?c=e[u]:(c=arguments[o],o+=1),i[u]=c,te(c)||(s-=1),u+=1}return s<=0?r.apply(this,i):ue(s,t(n,i,r))}}(t,[],n))})),Ee=ne((function(t){return Se(t.length,t)}));function Te(t){for(var n,e=[];!(n=t.next()).done;)e.push(n.value);return e}function Ae(t,n,e){for(var r=0,i=e.length;r<i;){if(t(n,e[r]))return!0;r+=1}return!1}function xe(t,n){return Object.prototype.hasOwnProperty.call(n,t)}var je="function"==typeof Object.is?Object.is:function(t,n){return t===n?0!==t||1/t==1/n:t!=t&&n!=n},Ie=Object.prototype.toString,qe=function(){return"[object Arguments]"===Ie.call(arguments)?function(t){return"[object Arguments]"===Ie.call(t)}:function(t){return xe("callee",t)}}(),He=!{toString:null}.propertyIsEnumerable("toString"),Pe=["constructor","valueOf","isPrototypeOf","toString","propertyIsEnumerable","hasOwnProperty","toLocaleString"],Re=function(){return arguments.propertyIsEnumerable("length")}(),ze=function(t,n){for(var e=0;e<t.length;){if(t[e]===n)return!0;e+=1}return!1},Ne="function"!=typeof Object.keys||Re?ne((function(t){if(Object(t)!==t)return[];var n,e,r=[],i=Re&&qe(t);for(n in t)!xe(n,t)||i&&"length"===n||(r[r.length]=n);if(He)for(e=Pe.length-1;e>=0;)xe(n=Pe[e],t)&&!ze(r,n)&&(r[r.length]=n),e-=1;return r})):ne((function(t){return Object(t)!==t?[]:Object.keys(t)})),Ce=ne((function(t){return null===t?"Null":void 0===t?"Undefined":Object.prototype.toString.call(t).slice(8,-1)}));function De(t,n,e,r){var i=Te(t);function o(t,n){return Me(t,n,e.slice(),r.slice())}return!Ae((function(t,n){return!Ae(o,n,t)}),Te(n),i)}function Me(t,n,e,r){if(je(t,n))return!0;var i,o,s=Ce(t);if(s!==Ce(n))return!1;if(null==t||null==n)return!1;if("function"==typeof t["fantasy-land/equals"]||"function"==typeof n["fantasy-land/equals"])return"function"==typeof t["fantasy-land/equals"]&&t["fantasy-land/equals"](n)&&"function"==typeof n["fantasy-land/equals"]&&n["fantasy-land/equals"](t);if("function"==typeof t.equals||"function"==typeof n.equals)return"function"==typeof t.equals&&t.equals(n)&&"function"==typeof n.equals&&n.equals(t);switch(s){case"Arguments":case"Array":case"Object":if("function"==typeof t.constructor&&"Promise"===(i=t.constructor,null==(o=String(i).match(/^function (\w*)/))?"":o[1]))return t===n;break;case"Boolean":case"Number":case"String":if(typeof t!=typeof n||!je(t.valueOf(),n.valueOf()))return!1;break;case"Date":if(!je(t.valueOf(),n.valueOf()))return!1;break;case"Error":return t.name===n.name&&t.message===n.message;case"RegExp":if(t.source!==n.source||t.global!==n.global||t.ignoreCase!==n.ignoreCase||t.multiline!==n.multiline||t.sticky!==n.sticky||t.unicode!==n.unicode)return!1}for(var u=e.length-1;u>=0;){if(e[u]===t)return r[u]===n;u-=1}switch(s){case"Map":return t.size===n.size&&De(t.entries(),n.entries(),e.concat([t]),r.concat([n]));case"Set":return t.size===n.size&&De(t.values(),n.values(),e.concat([t]),r.concat([n]));case"Arguments":case"Array":case"Object":case"Boolean":case"Number":case"String":case"Date":case"Error":case"RegExp":case"Int8Array":case"Uint8Array":case"Uint8ClampedArray":case"Int16Array":case"Uint16Array":case"Int32Array":case"Uint32Array":case"Float32Array":case"Float64Array":case"ArrayBuffer":break;default:return!1}var c=Ne(t);if(c.length!==Ne(n).length)return!1;var h=e.concat([t]),f=r.concat([n]);for(u=c.length-1;u>=0;){var a=c[u];if(!xe(a,n)||!Me(n[a],t[a],h,f))return!1;u-=1}return!0}var Be=re((function(t,n){return Me(t,n,[],[])}));function Ue(t,n){return function(t,n,e){var r,i;if("function"==typeof t.indexOf)switch(typeof n){case"number":if(0===n){for(r=1/n;e<t.length;){if(0===(i=t[e])&&1/i===r)return e;e+=1}return-1}if(n!=n){for(;e<t.length;){if("number"==typeof(i=t[e])&&i!=i)return e;e+=1}return-1}return t.indexOf(n,e);case"string":case"boolean":case"function":case"undefined":return t.indexOf(n,e);case"object":if(null===n)return t.indexOf(n,e)}for(;e<t.length;){if(Be(t[e],n))return e;e+=1}return-1}(n,t,0)>=0}var Ve=function(){function t(){this._nativeSet="function"==typeof Set?new Set:null,this._items={}}return t.prototype.add=function(t){return!Le(t,!0,this)},t.prototype.has=function(t){return Le(t,!1,this)},t}();function Le(t,n,e){var r,i=typeof t;switch(i){case"string":case"number":return 0===t&&1/t==-1/0?!!e._items["-0"]||(n&&(e._items["-0"]=!0),!1):null!==e._nativeSet?n?(r=e._nativeSet.size,e._nativeSet.add(t),e._nativeSet.size===r):e._nativeSet.has(t):i in e._items?t in e._items[i]||(n&&(e._items[i][t]=!0),!1):(n&&(e._items[i]={},e._items[i][t]=!0),!1);case"boolean":if(i in e._items){var o=t?1:0;return!!e._items[i][o]||(n&&(e._items[i][o]=!0),!1)}return n&&(e._items[i]=t?[!1,!0]:[!0,!1]),!1;case"function":return null!==e._nativeSet?n?(r=e._nativeSet.size,e._nativeSet.add(t),e._nativeSet.size===r):e._nativeSet.has(t):i in e._items?!!Ue(t,e._items[i])||(n&&e._items[i].push(t),!1):(n&&(e._items[i]=[t]),!1);case"undefined":return!!e._items[i]||(n&&(e._items[i]=!0),!1);case"object":if(null===t)return!!e._items.null||(n&&(e._items.null=!0),!1);default:return(i=Object.prototype.toString.call(t))in e._items?!!Ue(t,e._items[i])||(n&&e._items[i].push(t),!1):(n&&(e._items[i]=[t]),!1)}}var We=re((function(t,n){for(var e=[],r=0,i=t.length,o=n.length,s=new Ve,u=0;u<o;u+=1)s.add(n[u]);for(;r<i;)s.add(t[r])&&(e[e.length]=t[r]),r+=1;return e})),Fe=re((function(t,n){return Me(t,n,[],[])}));function Je(){if(0===arguments.length)throw new Error("pipe requires at least one argument");return ue(arguments[0].length,ge(ce,arguments[0],ke(arguments)))}var Ke=ne((function(t){return null!=t&&"function"==typeof t["fantasy-land/empty"]?t["fantasy-land/empty"]():null!=t&&null!=t.constructor&&"function"==typeof t.constructor["fantasy-land/empty"]?t.constructor["fantasy-land/empty"]():null!=t&&"function"==typeof t.empty?t.empty():null!=t&&null!=t.constructor&&"function"==typeof t.constructor.empty?t.constructor.empty():he(t)?[]:fe(t)?"":function(t){return"[object Object]"===Object.prototype.toString.call(t)}(t)?{}:qe(t)?function(){return arguments}():void 0})),Xe=ne((function(t){return null!=t&&Be(t,Ke(t))})),Ge=re(je),Qe=!{toString:null}.propertyIsEnumerable("toString"),Ye=["constructor","valueOf","isPrototypeOf","toString","propertyIsEnumerable","hasOwnProperty","toLocaleString"],Ze=function(){return arguments.propertyIsEnumerable("length")}(),$e=function(t,n){for(var e=0;e<t.length;){if(t[e]===n)return!0;e+=1}return!1},tr="function"!=typeof Object.keys||Ze?ne((function(t){if(Object(t)!==t)return[];var n,e,r=[],i=Ze&&qe(t);for(n in t)!xe(n,t)||i&&"length"===n||(r[r.length]=n);if(Qe)for(e=Ye.length-1;e>=0;)xe(n=Ye[e],t)&&!$e(r,n)&&(r[r.length]=n),e-=1;return r})):ne((function(t){return Object(t)!==t?[]:Object.keys(t)})),nr=ie((function(t,n,e){return Be(n,e[t])}));const er=/iPhone/.test(navigator.userAgent),rr="visualViewport"in window,ir=()=>screen.orientation.type.startsWith("portrait")?"portrait":"landscape",or=Ee(Oe(Jt,Dn((t,n)=>t?st():pt(n)))),sr=()=>document.activeElement&&document.activeElement!==document.body;t.default=function(t){if(er&&!rr)throw new Error("On-Screen-Keyboard detection not supported on this version of iOS");const[n,e]=Qn(),r=H();if(er){const i=Je(zn(t=>t.target.height===window.innerHeight?"hidden":"visible"),an,Un(e),Nn(t))(Xn(window.visualViewport));return Hn(i,r),n}const i=Math.max(700,700)-500+200,o=window.innerHeight,s=screen.availHeight-window.innerHeight,u=Cn(Fn(document.documentElement),Jn(document.documentElement)),c=se(Wn("visibilitychange",document))(Je(zn(()=>document.visibilityState),Rn(document.visibilityState))),h=se(u)(Je(zn(t=>"focusin"===t.type?pt(!1):ht(700,!0)),sn,Rn(!sr()),an,xn)),f=se(Kn(screen.orientation))(Je(Dn(t=>t||window.innerHeight===o,h),Ln(700),zn(t=>({screenOrientation:ir(),height:t?window.innerHeight:screen.availHeight-s})))),a=se(h)(Je(Mn(Ge(!0)),zn(()=>({screenOrientation:ir(),height:window.innerHeight})))),p=se(Xt([a,f]))(Je(Vn(1e3),or(zn(Fe("hidden"),c)),Pn((t,{screenOrientation:n,height:e})=>oe(n,e,t),{[ir()]:window.innerHeight}),Bn(Oe(Xe,We(["portrait","landscape"]),tr)))),l=se(Xn(window))(Je(Ln(500),zn(t=>({width:t.target.innerWidth,height:t.target.innerHeight})),Pn((t,n)=>({...n,isJustHeightResize:t.width===n.width,dH:n.height-t.height}),{width:window.innerWidth,height:window.innerHeight,isJustHeightResize:!1,dH:0}),Mn(nr("isJustHeightResize",!0)))),d=se(l)(Je(Vn(i),Dn((t,{height:n,dH:e})=>{const r=t[ir()];return r?n<.9*r&&e<0?pt("visible"):n===r&&e>0?pt("hidden"):st():e>.1*screen.availHeight?pt("hidden"):e<-.1*screen.availHeight?pt("visible"):st()},p),Jt,Cn(se(h)(Je(Mn(Ge(!0)),zn(ee("hidden"))))),Un(e),an));return Hn(Nn(t,d),r),n},Object.defineProperty(t,"__esModule",{value:!0})}));
